Imports System.IO


Partial Class Galerie
    Inherits System.Web.UI.Page

    Protected Sub btnUpload_Click(sender As Object, e As EventArgs) Handles btnUpload.Click
        ' berprfen ob eine Datei ausgewhlt wurde
        If Me.FileUpload1.HasFile = True Then
            ' Fehler Behandlung fr den Fall eines Fehlers beim Upload
            Try
                ' Den MIME type der Datei berprfen
                If Me.FileUpload1.PostedFile.ContentType = "image/jpeg" _
                  Or Me.FileUpload1.PostedFile.ContentType = "image/png" Then

                    ' berprfen ob die Datei max 1mb (1048576 Byte) gro ist
                    If Me.FileUpload1.PostedFile.ContentLength <= 1048576 Then

                        ' Den Namen der Datei in einer Variablen speichern
                        Dim Dateiname As String = Me.FileUpload1.FileName
                        ' Die Datei auf dem Server Speichern im Order Galerie
                        Me.FileUpload1.SaveAs(Server.MapPath("~/Galerie/") & Dateiname)
                        ' Erfolgsmeldung sichtbar machen
                        Me.lblErfolg.Visible = True
                        ' Fehlermeldung ausblenden
                        Me.lblFehler.Visible = False
                        ' List aktualisieren
                        BilderLaden()
                    Else
                        'Falls die Datei zu gro ist eine entsprechende Meldung ausgeben
                        ' Falls der Falsche Dateuityp ausgewhlt wurde eine Meldung ausgeben
                        Me.lblFehler.Text = "Es sind nur Dateien bis max. 1mb erlaubt"
                        Me.lblFehler.Visible = True
                        ' Erfolgsmeldung ausblenden
                        Me.lblErfolg.Visible = False
                    End If
                Else
                    ' Falls der Falsche Dateuityp ausgewhlt wurde eine Meldung ausgeben
                    Me.lblFehler.Text = "Es sind nur .jpg und .png Dateien erlaubt"
                    Me.lblFehler.Visible = True
                    ' Erfolgsmeldung ausblenden
                    Me.lblErfolg.Visible = False
                End If
            Catch ex As Exception
                ' Fehlermeldung setzen
                Me.lblFehler.Text = "Es ist ein Fehler aufgetreten"
                ' Fehlermeldung sichtbar machen
                Me.lblFehler.Visible = True
                ' Erfolgsmeldung ausblenden
                Me.lblErfolg.Visible = False
            End Try

        End If
    End Sub

    Private Sub BilderLaden()
        ' Den Order auswhlen in dem die bilde rgespeichert sind
        Dim Ordner As New DirectoryInfo(MapPath("~/Galerie"))
        ' Alle Dateien aus dem Order auslesen un in ein FileInfo Array speichern
        Dim Dateien As FileInfo() = Ordner.GetFiles()
        ' Ein Array deklarieren das als Datenquelle fr die DataList verwenet wird.
        Dim BilderListe As New ArrayList()
        ' Jede Datei im FileInfo Array "Dateien" durchgehen
        For Each Datei As FileInfo In Dateien
            ' Wenn die Dateiendung der aktuellen Datei .jpg .jpeg oder .png ist fgen wir die Datei
            ' dem BilderListe Array hinzu
            If Datei.Extension = ".jpg" Or Datei.Extension = ".jpeg" Or Datei.Extension = ".png" Then
                BilderListe.Add(Datei)
            End If
        Next
        ' Der DataList das Array als DataSource zuweisen
        dlBilder.DataSource = BilderListe
        ' Die Listebinden damit die Bilder angezegt werden
        dlBilder.DataBind()
    End Sub

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        ' Beim Laden der Seite all Bilder aus dem Ordner anzeigen
        BilderLaden()
    End Sub
End Class
