using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;
using System.Collections;

public partial class Galerie : System.Web.UI.Page
{
    protected void btnUpload_Click(object sender, EventArgs e)
    {
        // berprfen ob eine Datei ausgewhlt wurde        
        if (this.FileUpload1.HasFile == true)
        {
            // Fehler Behandlung fr den Fall eines Fehlers beim Upload
            try
            {
                // Den MIME type der Datei berprfen
                if (this.FileUpload1.PostedFile.ContentType == "image/jpeg" | this.FileUpload1.PostedFile.ContentType == "image/png")
                {
                    // berprfen ob die Datei max 1mb (1048576 Byte) gro ist
                    if (this.FileUpload1.PostedFile.ContentLength <= 1048576)
                    {
                        // Den Namen der Datei in einer Variablen speichern
                        string Dateiname = this.FileUpload1.FileName;
                        // Die Datei auf dem Server Speichern im Order Galerie
                        this.FileUpload1.SaveAs(Server.MapPath("~/Galerie/") + Dateiname);
                        // Erfolgsmeldung sichtbar machen
                        this.lblErfolg.Visible = true;
                        // Fehlermeldung ausblenden
                        this.lblFehler.Visible = false;
                        // List aktualisieren
                        BilderLaden();
                    }
                    else
                    {
                        //Falls die Datei zu gro ist eine entsprechende Meldung ausgeben
                        // Falls der Falsche Dateuityp ausgewhlt wurde eine Meldung ausgeben
                        this.lblFehler.Text = "Es sind nur Dateien bis max. 1mb erlaubt";
                        this.lblFehler.Visible = true;
                        // Erfolgsmeldung ausblenden
                        this.lblErfolg.Visible = false;
                    }
                }
                else
                {
                    // Falls der Falsche Dateuityp ausgewhlt wurde eine Meldung ausgeben
                    this.lblFehler.Text = "Es sind nur .jpg und .png Dateien erlaubt";
                    this.lblFehler.Visible = true;
                    // Erfolgsmeldung ausblenden
                    this.lblErfolg.Visible = false;
                }
            }
            catch (Exception ex)
            {
                // Fehlermeldung setzen
                this.lblFehler.Text = "Es ist ein Fehler aufgetreten";
                // Fehlermeldung sichtbar machen
                this.lblFehler.Visible = true;
                // Erfolgsmeldung ausblenden
                this.lblErfolg.Visible = false;
            }
        }
    }

    private void BilderLaden()
    {
        // Den Order auswhlen in dem die bilde rgespeichert sind
        DirectoryInfo Ordner = new DirectoryInfo(MapPath("~/Galerie"));
        // Alle Dateien aus dem Order auslesen un in ein FileInfo Array speichern
        FileInfo[] Dateien = Ordner.GetFiles();
        // Ein Array deklarieren das als Datenquelle fr die DataList verwenet wird.
        ArrayList BilderListe = new ArrayList();
        // Jede Datei im FileInfo Array "Dateien" durchgehen
        foreach (FileInfo Datei in Dateien)
        {
            // Wenn die Dateiendung der aktuellen Datei .jpg .jpeg oder .png ist fgen wir die Datei
            // dem BilderListe Array hinzu
            if (Datei.Extension == ".jpg" | Datei.Extension == ".jpeg" | Datei.Extension == ".png")
            {
                BilderListe.Add(Datei);
            }
        }
        // Der DataList das Array als DataSource zuweisen
        dlBilder.DataSource = BilderListe;
        // Die Listebinden damit die Bilder angezegt werden
        dlBilder.DataBind();
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        // Beim Laden der Seite all Bilder aus dem Ordner anzeigen
        BilderLaden();
    }
}